## efivar 37

=== docs/Makefile ===
SRCDIR = $(realpath .)
TOPDIR = $(realpath ..)

include $(TOPDIR)/Make.deprecated
include $(TOPDIR)/Make.version
include $(TOPDIR)/Make.rules
include $(TOPDIR)/Make.defaults

MAN1TARGETS = efivar.1
MAN3TARGETS = efi_append_variable.3 \
	     efi_del_variable.3 \
	     efi_get_next_variable_name.3 \
	     efi_get_variable.3 \
	     efi_get_variable_attributes.3 \
	     efi_get_variable_size.3 \
	     efi_guid_to_id_guid.3 \
	     efi_guid_to_name.3 \
	     efi_guid_to_str.3 \
	     efi_guid_to_symbol.3 \
	     efi_name_to_guid.3 \
	     efi_set_variable.3 \
	     efi_str_to_guid.3 \
	     efi_symbol_to_guid.3 \
	     efi_variables_supported.3 \
	     efi_variable_t.3 \
	     efi_variable_import.3 \
	     efi_variable_export.3 \
	     efi_variable_alloc.3 \
	     efi_variable_free.3 \
	     efi_variable_set_name.3 \
	     efi_variable_get_name.3 \
	     efi_variable_set_guid.3 \
	     efi_variable_get_guid.3 \
	     efi_variable_set_data.3 \
	     efi_variable_get_data.3 \
	     efi_variable_get_attributes.3 \
	     efi_variable_set_attributes.3 \
	     efi_variable_realize.3

all :

clean :

test :

install :
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(foreach x, $(MAN1TARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(MANDIR)/man1/;)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man3
	$(foreach x, $(MAN3TARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(MANDIR)/man3/;)

.PHONY: all clean install

include $(TOPDIR)/Make.rules

=== src/Makefile ===
SRCDIR = $(realpath .)
TOPDIR = $(realpath ..)

include $(TOPDIR)/Make.deprecated
include $(TOPDIR)/Make.version
include $(TOPDIR)/Make.rules
include $(TOPDIR)/Make.defaults

LIBTARGETS=libefivar.so libefiboot.so
STATICLIBTARGETS=libefivar.a libefiboot.a
BINTARGETS=efivar
STATICBINTARGETS=efivar-static
PCTARGETS=efivar.pc efiboot.pc
TARGETS=$(LIBTARGETS) $(BINTARGETS) $(PCTARGETS)
STATICTARGETS=$(STATICLIBTARGETS) $(STATICBINTARGETS)

LIBEFIBOOT_SOURCES = crc32.c creator.c disk.c gpt.c loadopt.c path-helpers.c \
		     linux.c $(wildcard linux-*.c)
LIBEFIBOOT_OBJECTS = $(patsubst %.c,%.o,$(LIBEFIBOOT_SOURCES))
LIBEFIVAR_SOURCES = dp.c dp-acpi.c dp-hw.c dp-media.c dp-message.c \
	efivarfs.c error.c export.c guid.c guids.S guid-symbols.c \
	lib.c vars.c
LIBEFIVAR_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(LIBEFIVAR_SOURCES)))
EFIVAR_SOURCES = efivar.c
GENERATED_SOURCES = include/efivar/efivar-guids.h guid-symbols.c
MAKEGUIDS_SOURCES = makeguids.c guid.c
ALL_SOURCES=$(LIBEFIBOOT_SOURCES) $(LIBEFIVAR_SOURCES) $(MAKEGUIDS_SOURCES) \
	$(wildcard include/efivar/*.h) $(GENERATED_SOURCES) $(EFIVAR_SOURCES)

$(call deps-of,$(ALL_SOURCES)) : | deps
-include $(call deps-of,$(ALL_SOURCES))

all : $(TARGETS)

static : $(STATICTARGETS)

abiclean :
	@rm -vf $(patsubst %.so,%.abixml,$@)

abixml : | $(LIBTARGETS)
abixml : $(patsubst %.so,%.abixml,$(LIBTARGETS))

abidw : $(patsubst %.so,%.abixml,$(LIBTARGETS))
	git commit -s --amend $^

abicheck : $(patsubst %.so,%.abicheck,$(LIBTARGETS))

./guid-symbols.c : include/efivar/efivar-guids.h
./guids.bin : include/efivar/efivar-guids.h
./names.bin : include/efivar/efivar-guids.h
include/efivar/efivar-guids.h : makeguids guids.txt
	./makeguids guids.txt guids.bin names.bin \
		guid-symbols.c include/efivar/efivar-guids.h

makeguids : CPPFLAGS+=-DEFIVAR_BUILD_ENVIRONMENT
makeguids : LIBS=dl
makeguids : $(MAKEGUIDS_SOURCES)
makeguids : CCLD=$(CCLD_FOR_BUILD)

guids.o : guids.S | guids.bin names.bin

$(LIBEFIVAR_OBJECTS) $(LIBEFIBOOT_OBJECTS) : | $(GENERATED_SOURCES)

libefivar.a : | $(GENERATED_SOURCES)
libefivar.a : $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))

libefivar.so : $(LIBEFIVAR_OBJECTS)
libefivar.so : | $(GENERATED_SOURCES) libefivar.map
libefivar.so : LIBS=dl
libefivar.so : MAP=libefivar.map

efivar : efivar.c | libefivar.so
efivar : LIBS=efivar dl

efivar-static : efivar.c $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))
efivar-static : | $(GENERATED_SOURCES)
efivar-static : LIBS=dl

libefiboot.a : $(patsubst %.o,%.static.o,$(LIBEFIBOOT_OBJECTS))

libefiboot.so : $(LIBEFIBOOT_OBJECTS)
libefiboot.so : | libefiboot.map libefivar.so
libefiboot.so : LIBS=efivar
libefiboot.so : MAP=libefiboot.map

deps : $(ALL_SOURCES)
	$(MAKE) -f $(SRCDIR)/Make.deps deps SOURCES="$(ALL_SOURCES)"

clean : 
	@rm -rfv *~ *.o *.a *.E *.so *.so.* *.pc *.bin .*.d *.map \
		makeguids guid-symbols.c include/efivar/efivar-guids.h \
		$(TARGETS) $(STATICTARGETS)
	@# remove the deps files we used to create, as well.
	@rm -rfv .*.P .*.h.P *.S.P include/efivar/.*.h.P

install : all
	$(INSTALL) -d -m 755 $(DESTDIR)$(LIBDIR)
	$(foreach x,$(LIBTARGETS), \
		$(INSTALL) -m 755 $(x) $(DESTDIR)$(LIBDIR)/$(x).1.$(VERSION) ;\
		ln -fs $(x).1.$(VERSION) $(DESTDIR)$(LIBDIR)/$(x).1 ;\
		ln -fs $(x).1.$(VERSION) $(DESTDIR)$(LIBDIR)/$(x) ;\
		)
	$(INSTALL) -d -m 755 $(DESTDIR)$(PCDIR)
	$(foreach x, $(PCTARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)$(PCDIR) ;)
	$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)/efivar
	$(foreach x, $(wildcard $(TOPDIR)/src/include/efivar/*.h), $(INSTALL) -m 644 $(x) $(DESTDIR)$(INCLUDEDIR)/efivar/$(notdir $(x));)
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(foreach x, $(BINTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)$(BINDIR);)

test : all
	$(MAKE) -C test $@

.PHONY: test deps abiclean abixml
.SECONDARY : libefivar.so.1.$(VERSION) libefivar.so.1
.SECONDARY : libefiboot.so.1.$(VERSION) libefivar.so.1
.SECONDARY : include/efivar/efivar-guids.h guid-symbols.c
.INTERMEDIATE : guids.bin names.bin
.PRECIOUS : guid-symbols.o makeguids

=== debian/changelog ===
efivar (37-6ubuntu2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:11:08 +0200

efivar (37-6ubuntu1) hirsute; urgency=medium

  * Ignore stringop-truncation warnings in text_to_guid, seen when building
    with lto.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 29 Mar 2021 12:59:06 +0200

efivar (37-6) unstable; urgency=medium

  [ dann frazier ]
  * Add support for nvme-fabrics and nvme-subsystem devices. LP: #1891718.

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 16 Nov 2020 18:37:50 -0600

efivar (37-5) unstable; urgency=medium

  * Cherrypick upstream patch to enable CET on amd64.
  * Cherrypick upstream patch to fix uninitialized variable in
    parse_acpi_root(), which can lead to a segfault when calling
    grub-install. LP: #1892792.

 -- dann frazier <dannf@debian.org>  Mon, 24 Aug 2020 12:18:22 -0600

efivar (37-4) unstable; urgency=medium

  [ dann frazier ]
  * Fix FTBFS with GCC-10. (Closes: #966915)

  [ Ryan Finnie ]
  * Enable riscv64 build. (Closes: #959499)

  [ dann frazier ]
  * Bump debhelper compat to 12.

 -- dann frazier <dannf@debian.org>  Wed, 19 Aug 2020 07:12:28 -0600

efivar (37-3) unstable; urgency=medium

  [ Mario Limonciello ]
  * Drop Jared from uploaders.

  [ dann frazier ]
  * Backport changes from upstream to fix efibootmgr -v output.
    (Closes: #963475)

 -- Mario Limonciello <mario.limonciello@dell.com>  Tue, 18 Aug 2020 14:55:25 -0500

efivar (37-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: added upstream patches fix-gcc9-werror-format-guid.patch
    and fix-gcc9-werrors.patch to fix FTBFS with GCC 9. Thanks to Matthias
    Klose <doko@ubuntu.com>. (Closes: #925672)

 -- David da Silva Polverari <david.polverari@gmail.com>  Tue, 09 Jun 2020 17:31:58 -0500

efivar (37-2) unstable; urgency=medium

  * Cherry-pick fix from upstream:
    + Get rid of the arrows in our debug messages. (Closes: #922680)

 -- Steve McIntyre <93sam@debian.org>  Fri, 01 Mar 2019 17:55:07 +0000

efivar (37-1) unstable; urgency=medium

  * New upstream version (37)
  * debian/rules:
    - Correct for new Makefile variables.

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 05 Dec 2018 20:33:40 -0600

=== debian/control ===
Source: efivar
Priority: optional
Maintainer: Debian UEFI Maintainers <debian-efi@lists.debian.org>
Uploaders: Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
Build-Depends: debhelper-compat (= 12), libpopt-dev, pkg-config
Standards-Version: 4.1.1
Section: libs
Homepage: https://github.com/rhinstaller/efivar
Vcs-Git: https://salsa.debian.org/efi-team/efivar.git
Vcs-Browser: https://salsa.debian.org/efi-team/efivar

Package: libefivar-dev
Section: libdevel
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32
Multi-Arch: same
Depends: libefivar1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefivar
 development headers required to use libefivar

Package: libefiboot-dev
Section: libdevel
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32
Multi-Arch: same
Depends: libefiboot1 (= ${binary:Version}), ${misc:Depends}
Conflicts: libefivar-dev (<< 27-1)
Replaces: libefivar-dev (<< 27-1)
Description: Development headers for libefiboot
 development headers required to use libefiboot

Package: efivar
Section: admin
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libefivar1 (= ${binary:Version}), libefiboot1 (= ${binary:Version})
Description: Tools to manage UEFI variables
 efivar provides a simple command line interface to the UEFI variable facility.

Package: libefiboot1
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: efibootmgr (<< 0.12-2)
Description: Library to manage UEFI variables
 Library to allow for the manipulation of UEFI variables related to booting.

Package: libefivar1
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: efibootmgr (<< 0.12-2)
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DH_OPTIONS=-V

include /usr/share/dpkg/default.mk

export DEB_CFLAGS_MAINT_APPEND= -flto -flto-partition=none
export DEB_LDFLAGS_MAINT_APPEND= -flto -flto-partition=none
ifeq ($(DEB_HOST_ARCH),amd64)
export DEB_CFLAGS_MAINT_APPEND+= -fcf-protection
export DEB_LDFLAGS_MAINT_APPEND+= -fcf-protection
endif

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- LIBDIR=\$${PREFIX}/lib/$(DEB_HOST_MULTIARCH) CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-

override_dh_auto_install:
	dh_auto_install -- LIBDIR=\$${PREFIX}/lib/$(DEB_HOST_MULTIARCH)

## efivar 38

=== docs/Makefile ===
--- 
+++ 
@@ -1,12 +1,13 @@
 SRCDIR = $(realpath .)
-TOPDIR = $(realpath ..)
 
-include $(TOPDIR)/Make.deprecated
-include $(TOPDIR)/Make.version
-include $(TOPDIR)/Make.rules
-include $(TOPDIR)/Make.defaults
+include $(TOPDIR)/src/include/deprecated.mk
+include $(TOPDIR)/src/include/version.mk
+include $(TOPDIR)/src/include/rules.mk
+include $(TOPDIR)/src/include/defaults.mk
 
-MAN1TARGETS = efivar.1
+MAN1TARGETS = efisecdb.1 \
+	      efivar.1
+
 MAN3TARGETS = efi_append_variable.3 \
 	     efi_del_variable.3 \
 	     efi_get_next_variable_name.3 \
@@ -37,13 +38,16 @@
 	     efi_variable_set_attributes.3 \
 	     efi_variable_realize.3
 
-all :
+all : $(MAN1TARGETS) $(MAN3TARGETS)
 
 clean :
+	@rm -f efisecdb.1
+
+prep :
 
 test :
 
-install :
+install : $(MAN1TARGETS) $(MAN3TARGETS)
 	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
 	$(foreach x, $(MAN1TARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(MANDIR)/man1/;)
 	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man3
@@ -51,4 +55,4 @@
 
 .PHONY: all clean install
 
-include $(TOPDIR)/Make.rules
+include $(TOPDIR)/src/include/rules.mk

=== src/Makefile ===
SRCDIR = $(realpath .)

include $(TOPDIR)/src/include/deprecated.mk
include $(TOPDIR)/src/include/version.mk
include $(TOPDIR)/src/include/rules.mk
include $(TOPDIR)/src/include/defaults.mk
include $(TOPDIR)/src/include/workarounds.mk

LIBTARGETS=libefivar.so libefiboot.so libefisec.so
STATICLIBTARGETS=libefivar.a libefiboot.a libefisec.a
BINTARGETS=efivar efisecdb thread-test
STATICBINTARGETS=efivar-static efisecdb-static
PCTARGETS=efivar.pc efiboot.pc efisec.pc
TARGETS=$(LIBTARGETS) $(BINTARGETS) $(PCTARGETS)
STATICTARGETS=$(STATICLIBTARGETS) $(STATICBINTARGETS)

LIBEFISEC_SOURCES = sec.c secdb.c esl-iter.c util.c
LIBEFISEC_OBJECTS = $(patsubst %.c,%.o,$(LIBEFISEC_SOURCES))
LIBEFIBOOT_SOURCES = crc32.c creator.c disk.c gpt.c loadopt.c path-helpers.c \
		     linux.c $(sort $(wildcard linux-*.c))
LIBEFIBOOT_OBJECTS = $(patsubst %.c,%.o,$(LIBEFIBOOT_SOURCES))
LIBEFIVAR_SOURCES = crc32.c dp.c dp-acpi.c dp-hw.c dp-media.c dp-message.c \
	efivarfs.c error.c export.c guid.c guid-symbols.c \
	lib.c vars.c time.c
LIBEFIVAR_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(LIBEFIVAR_SOURCES)))
EFIVAR_SOURCES = efivar.c guid.c util.c
EFIVAR_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(EFIVAR_SOURCES)))
EFISECDB_SOURCES = efisecdb.c guid-symbols.c secdb-dump.c util.c
EFISECDB_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(EFISECDB_SOURCES)))
GENERATED_SOURCES = include/efivar/efivar-guids.h guid-symbols.c
MAKEGUIDS_SOURCES = makeguids.c util.c
MAKEGUIDS_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(MAKEGUIDS_SOURCES)))
MAKEGUIDS_OUTPUT = $(GENERATED_SOURCES) guids.lds

ALL_SOURCES=$(LIBEFISEC_SOURCES) $(LIBEFIBOOT_SOURCES) $(LIBEFIVAR_SOURCES) \
	    $(MAKEGUIDS_SOURCES) $(GENERATED_SOURCES) $(EFIVAR_SOURCES) \
	    $(sort $(wildcard include/efivar/*.h))

ifneq ($(MAKECMDGOALS),clean)
$(call deps-of,$(ALL_SOURCES)) : | deps
-include $(call deps-of,$(ALL_SOURCES))
endif

all : $(TARGETS)

static : $(STATICTARGETS)

$(BINTARGETS) : | $(LIBTARGETS) $(PCTARGETS)
$(STATICTARGETS) : | $(STATICLIBTARGETS) $(PCTARGETS)

abiclean :
	@rm -vf $(patsubst %.so,%.abixml,$@)

abixml : | $(LIBTARGETS)
abixml : $(patsubst %.so,%.abixml,$(LIBTARGETS))

abidw : $(patsubst %.so,%.abixml,$(LIBTARGETS))
	git commit -s --amend $^

abicheck : $(patsubst %.so,%.abicheck,$(LIBTARGETS))

makeguids : CPPFLAGS=$(HOST_CPPFLAGS)
makeguids : LIBS=dl
makeguids : CC=$(HOSTCC)
makeguids : CCLD=$(HOSTCCLD)
makeguids : CFLAGS=$(HOST_CFLAGS)
makeguids : LDFLAGS=$(HOST_LDFLAGS)
makeguids : CCLDFLAGS=$(HOST_CCLDFLAGS)
makeguids : $(MAKEGUIDS_OBJECTS)

$(MAKEGUIDS_OUTPUT) : makeguids
$(MAKEGUIDS_OUTPUT) : guids.txt
	@set -e ; \
	missing=no ; \
	for x in $$(cat guids.txt  | awk '{ print $$2 }' | grep -v ^zz) ; do \
		if ! grep -q "efi_guid_$${x}" libefivar.map.in ; then \
			echo missing symbol "efi_guid_$${x}" ; \
			missing=yes ; \
		fi ; \
	done ; \
	if [ "$${missing}" != "no" ]; then \
		exit 1 ; \
	fi
	./makeguids $(LD_DASH_T) guids.txt guid-symbols.c include/efivar/efivar-guids.h guids.lds

prep : makeguids $(GENERATED_SOURCES)

$(LIBEFIVAR_OBJECTS) $(LIBEFIBOOT_OBJECTS) : prep

libefivar.a : | $(GENERATED_SOURCES)
libefivar.a : $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))

libefivar.so : $(LIBEFIVAR_OBJECTS)
libefivar.so : | $(GENERATED_SOURCES) libefivar.map
libefivar.so : LIBS=dl
libefivar.so : LDSCRIPTS=guids.lds
libefivar.so : MAP=libefivar.map

efivar : $(EFIVAR_OBJECTS) | libefivar.so
efivar : LIBS=efivar dl

efivar-static : $(EFIVAR_OBJECTS) $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))
efivar-static : | $(GENERATED_SOURCES)
efivar-static : LIBS=dl

libefiboot.a : $(patsubst %.o,%.static.o,$(LIBEFIBOOT_OBJECTS))

libefiboot.so : $(LIBEFIBOOT_OBJECTS)
libefiboot.so : | libefiboot.map libefivar.so
libefiboot.so : LIBS=efivar
libefiboot.so : MAP=libefiboot.map

libefisec.a : $(patsubst %.o,%.static.o,$(LIBEFISEC_OBJECTS))

libefisec.so : $(LIBEFISEC_OBJECTS)
libefisec.so : | libefisec.map
libefisec.so : MAP=libefisec.map

efisecdb : $(EFISECDB_OBJECTS) | libefisec.so
efisecdb : LIBS=efivar efisec dl

efisecdb-static : $(EFISECDB_OBJECTS)
efisecdb-static : $(patsubst %.o,%.static.o,$(LIBEFISEC_OBJECTS) $(LIBEFIVAR_OBJECTS))
efisecdb-static : | $(GENERATED_SOURCES)
efisecdb-static : LIBS=dl

thread-test : libefivar.so
thread-test : CFLAGS=$(HOST_CFLAGS) -I$(TOPDIR)/src/include/efivar
thread-test : LIBS=pthread efivar

deps : $(ALL_SOURCES)
	@$(MAKE) -f $(SRCDIR)/include/deps.mk deps SOURCES="$(ALL_SOURCES)"

clean : 
	@rm -rfv *~ *.o *.a *.E *.so *.so.* *.pc *.bin .*.d *.map \
		makeguids guid-symbols.c include/efivar/efivar-guids.h \
		guids.lds \
		$(TARGETS) $(STATICTARGETS)
	@# remove the deps files we used to create, as well.
	@rm -rfv .*.P .*.h.P *.S.P include/efivar/.*.h.P

install : all
	$(INSTALL) -d -m 755 $(DESTDIR)$(LIBDIR)
	$(foreach x,$(LIBTARGETS), \
		$(INSTALL) -m 755 $(x) $(DESTDIR)$(LIBDIR)/$(x).1.$(VERSION) ;\
		ln -fs $(x).1.$(VERSION) $(DESTDIR)$(LIBDIR)/$(x).1 ;\
		ln -fs $(x).1.$(VERSION) $(DESTDIR)$(LIBDIR)/$(x) ;\
		)
	$(INSTALL) -d -m 755 $(DESTDIR)$(PCDIR)
	$(foreach x, $(PCTARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)$(PCDIR) ;)
	$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)/efivar
	$(foreach x, $(sort $(wildcard $(TOPDIR)/src/include/efivar/*.h)), $(INSTALL) -m 644 $(x) $(DESTDIR)$(INCLUDEDIR)/efivar/$(notdir $(x));)
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(foreach x, $(filter-out %-test,$(BINTARGETS)), $(INSTALL) -m 755 $(x) $(DESTDIR)$(BINDIR);)

test : all
	$(MAKE) -C test $@

.PHONY: abiclean abicheck abidw abixml all
.PHONY: clean deps install test
.SECONDARY : libefivar.so.1.$(VERSION) libefivar.so.1
.SECONDARY : libefiboot.so.1.$(VERSION) libefiboot.so.1
.SECONDARY : libefisec.so.1.$(VERSION) libefisec.so.1
.SECONDARY : $(GENERATED_SOURCES)
.INTERMEDIATE : guids.bin names.bin
.PRECIOUS : makeguids

=== tests/Makefile ===
#
# Makefile
# Peter Jones, 2019-06-18 11:10
#

TESTS = test.dmpstore.export \
	test.efivar.export \
	test.grubenv.var \
	test.bootorder.var \
	test.conin.var \
	test.efivar.threading \
	test.parse.db \
	test.esl.annotation \
	test.esl.sha256.unsorted \
	test.esl.sha256.ascending \
	test.esl.sha256.removal.descending \
	test.esl.sha256.addition.unsorted \
	test.esl.cert.addition \
	test.esl.cert.removal

all: clean $(TESTS)

GRUB_PREFIX ?= grub2
VALGRIND ?=

V ?= 0
ifeq ($(V),0)
        quiet=@
        rmverbose=
else
        quiet=
        rmverbose=-v
endif
ifeq ($(V),2)
        loud=-vvvv
else
        loud=
endif

EFIVAR ?= $(VALGRIND) $(TOPDIR)/src/efivar $(loud)
EFISECDB ?= $(VALGRIND) $(TOPDIR)/src/efisecdb $(loud)

EFIVAR ?= $(VALGRIND) $(TOPDIR)/src/efivar $(loud)

clean:
	$(quiet)rm $(rmverbose) -f test.*.result* \
		test.esl.annotation.esl.result \
		test.esl.cert.addition.esl.goal.txt \
		test.esl.cert.removal.esl.goal.txt \
		test.esl.sha256.addition.unsorted.esl.goal.txt \
		test.esl.sha256.ascending.esl.goal.txt \
		test.esl.sha256.removal.descending.esl.goal.txt \
		test.esl.sha256.unsorted.esl.goal.txt

test.dmpstore.export:
	$(quiet)echo testing export to DMPSTORE format
	$(quiet)$(GRUB_PREFIX)-editenv test.dmpstore.export.result.env create
	$(quiet)$(GRUB_PREFIX)-editenv test.dmpstore.export.result.env set debug=all,-scripting,-lexer
	$(quiet)truncate -s 512 test.dmpstore.export.result.env
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n {grub}-GRUB_ENV -f test.dmpstore.export.result.env -D -e test.dmpstore.export.result.var
	$(quiet)@if grep -q "Do not edit" test.dmpstore.export.result.env ; then \
		cmp test.dmpstore.export.result.var test.dmpstore.export.new.goal.var ; \
	else \
		cmp test.dmpstore.export.result.var test.dmpstore.export.old.goal.var ; \
	fi
	$(quiet)rm -f test.dmpstore.export.result.*
	$(quiet)echo passed

test.efivar.export:
	$(quiet)echo testing export to libefivar format
	$(quiet)$(GRUB_PREFIX)-editenv test.efivar.export.result.env create
	$(quiet)$(GRUB_PREFIX)-editenv test.efivar.export.result.env set debug=all,-scripting,-lexer
	$(quiet)truncate -s 512 test.efivar.export.result.env
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n {grub}-GRUB_ENV -f test.efivar.export.result.env -e test.efivar.export.result.var
	$(quiet)if grep -q "Do not edit" test.efivar.export.result.env ; then \
		cmp test.efivar.export.result.var test.efivar.export.new.goal.var ; \
	else \
		cmp test.efivar.export.result.var test.efivar.export.old.goal.var ; \
	fi
	$(quiet)rm -f test.efivar.export.result.*
	$(quiet)echo passed

test.grubenv.var:
	$(quiet)$(GRUB_PREFIX)-editenv test.grubenv.var.result.env create
	$(quiet)$(GRUB_PREFIX)-editenv test.grubenv.var.result.env set debug=all,-scripting,-lexer
	$(quiet)truncate -s 512 test.grubenv.var.result.env
	$(quiet)echo test importing from DMPSTORE and exporting to DMPSTORE and symbolic guid-name validation
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n {grub}-GRUB_ENV -f test.grubenv.var.result.env -D -e test.grubenv.var.0.export.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.grubenv.var.0.export.var -e test.grubenv.var.0.result.var -D
	$(quiet)if grep -q "Do not edit" test.grubenv.var.result.env ; then \
		cmp test.grubenv.var.0.result.var test.grubenv.var.0.new.goal.var ; \
	else \
		cmp test.grubenv.var.0.result.var test.grubenv.var.0.old.goal.var ; \
	fi
	$(quiet)rm test.grubenv.var.0.result.*
	$(quiet)echo passed
	$(quiet)echo test importing from DMPSTORE and exporting to libefivar
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n {grub}-GRUB_ENV -f test.grubenv.var.result.env -D -e test.grubenv.var.1.export.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.grubenv.var.1.export.var -e test.grubenv.var.1.result.var
	$(quiet)if grep -q "Do not edit" test.grubenv.var.result.env ; then \
		cmp test.grubenv.var.1.result.var test.grubenv.var.1.new.goal.var ; \
	else \
		cmp test.grubenv.var.1.result.var test.grubenv.var.1.old.goal.var ; \
	fi
	$(quiet)rm test.grubenv.var.1.result.*
	$(quiet)echo passed
	$(quiet)echo test importing from libefivar and exporting to DMPSTORE and mixed-case guid-name validation
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n 91376aff-cBa6-42bE-949d-06fde81128e8-GRUB_ENV -f test.grubenv.var.result.env -e test.grubenv.var.2.export.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.grubenv.var.2.export.var -e test.grubenv.var.2.result.var -D
	$(quiet)if grep -q "Do not edit" test.grubenv.var.result.env ; then \
		cmp test.grubenv.var.2.result.var test.grubenv.var.2.new.goal.var ; \
	else \
		cmp test.grubenv.var.2.result.var test.grubenv.var.2.old.goal.var ; \
	fi
	$(quiet)rm test.grubenv.var.2.result.*
	$(quiet)echo passed
	$(quiet)echo test importing from libefivar and exporting to libefivar and guid-name validation
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -n 91376aff-cba6-42be-949d-06fde81128e8-GRUB_ENV -f test.grubenv.var.result.env -e test.grubenv.var.3.export.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.grubenv.var.3.export.var -e test.grubenv.var.3.result.var
	$(quiet)if grep -q "Do not edit" test.grubenv.var.result.env ; then \
		cmp test.grubenv.var.3.result.var test.grubenv.var.3.new.goal.var ; \
	else \
		cmp test.grubenv.var.3.result.var test.grubenv.var.3.old.goal.var ; \
	fi
	$(quiet)rm -f test.grubenv.var.3.result.* test.grubenv.var.result.env test.grubenv.var.3.goal.var
	$(quiet)echo passed
	$(quiet)echo testing efivar -L
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -L | \
		grep -q '^{91376aff-cba6-42be-949d-06fde81128e8}	{grub}	efi_guid_grub	GRUB$$'
	$(quiet)echo passed

test.bootorder.var:
	$(quiet)echo testing with BootOrder variable dmpstore generated
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.bootorder.var.goal.var -e test.bootorder.var.0.result.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.bootorder.var.0.result.var -e test.bootorder.var.1.result.var -D
	$(quiet)cmp test.bootorder.var.goal.var test.bootorder.var.1.result.var
	$(quiet)echo passed

test.conin.var:
	$(quiet)echo testing with ConIn variable dmpstore generated
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.conin.var.goal.var -e test.conin.var.0.result.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFIVAR) -i test.conin.var.0.result.var -e test.conin.var.1.result.var -D
	$(quiet)cmp test.conin.var.goal.var test.conin.var.1.result.var
	$(quiet)echo passed

test.efivar.threading:
	$(quiet)echo testing threading in libefivar
	$(quiet)TOPDIR=$(TOPDIR) $(TOPDIR)/tests/test-threading

test.esl.dump.x509.sha256:
	$(quiet)echo testing ESL dumping with x509 + sha256 sums
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) \
		-i test.esl.sha256.addition.unsorted.esl.goal -A > test.esl.dump.x509.sha256.result.txt
	$(quiet)cmp test.esl.dump.x509.sha256.goal.txt test.esl.sha256.addition.unsorted.result.txt
	$(quiet)echo passed

%.goal.txt : %.goal
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src ../src/efisecdb --dump --annotate \
		-s none -i $< > $@

%.result.txt : %.result
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src ../src/efisecdb --dump --annotate \
		-s none -i $< > $@

%.var.result.txt : %.var
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src ../src/efisecdb --dump --annotate \
		-s none -i $< > $@

test.parse.db: test.parse.db.var.result.txt
	$(quiet)echo testing parsing db variable
	$(quiet)if ! cmp test.parse.db.var.goal.txt test.parse.db.var.result.txt ; then \
		diff -U 200 test.parse.db.var.goal.txt test.parse.db.var.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.annotation.esl.result : test.esl.annotation.esl
	$(quiet)cp $(rmverbose) $< $@

test.esl.annotation: test.esl.annotation.esl.goal.txt
test.esl.annotation: test.esl.annotation.esl.result.txt
	$(quiet)echo testing ESL annotation with x509 + sha256 sums
	$(quiet)if ! cmp $@.esl.goal.txt $@.esl.result.txt ; then \
		diff -U 200 $@.esl.goal.txt $@.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.sha256.unsorted.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 -a \
		-h 87428fc522803d31065e7bce3cf03fe475096631e5e07bbd7a0fde60c4cf25c7 \
		-h 0263829989b6fd954f72baaf2fc64bc2e2f01d692d4de72986ea808f6e99813f \
		-h a3a5e715f0cc574a73c3f9bebb6bc24f32ffd5b67b387244c2c909da779a1478 \
		-h 8d74beec1be996322ad76813bafb92d40839895d6dd7ee808b17ca201eac98be \
		-s none -f -o $@

test.esl.sha256.unsorted: test.esl.sha256.unsorted.esl.result.txt test.esl.sha256.unsorted.esl.goal.txt
	$(quiet)echo testing ESL creation with sha256 sums '(unsorted)'
	$(quiet)if ! cmp $@.esl.goal $@.esl.result ; then \
		diff -U 200 $@.esl.goal.txt $@.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.sha256.ascending.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 -a \
		-h 87428fc522803d31065e7bce3cf03fe475096631e5e07bbd7a0fde60c4cf25c7 \
		-h 0263829989b6fd954f72baaf2fc64bc2e2f01d692d4de72986ea808f6e99813f \
		-h a3a5e715f0cc574a73c3f9bebb6bc24f32ffd5b67b387244c2c909da779a1478 \
		-h 8d74beec1be996322ad76813bafb92d40839895d6dd7ee808b17ca201eac98be \
		-s data -s ascending -f -o $@

test.esl.sha256.ascending: test.esl.sha256.ascending.esl.goal.txt test.esl.sha256.ascending.esl.result.txt
	$(quiet)echo testing ESL creation with sha256 sums '(ascending)'
	$(quiet)if ! cmp $@.esl.goal $@.esl.result ; then \
		diff -U 200 $@.esl.goal.txt $@.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.sha256.removal.descending.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 \
		-i test.esl.sha256.unsorted.esl.goal -r \
		-h a3a5e715f0cc574a73c3f9bebb6bc24f32ffd5b67b387244c2c909da779a1478 \
		-s data -s descending -f -o $@

test.esl.sha256.removal.descending: test.esl.sha256.removal.descending.esl.result.txt
test.esl.sha256.removal.descending: test.esl.sha256.removal.descending.esl.goal.txt
	$(quiet)echo testing ESL entry removal with sha256 sums '(descending)'
	$(quiet)if ! cmp $@.esl.goal $@.esl.result ; then \
		diff -U 200 $@.esl.goal.txt $@.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.sha256.addition.unsorted.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 \
		-i test.esl.sha256.addition.unsorted.esl.goal -a \
		-h a3a5e715f0cc574a73c3f9bebb6bc24f32ffd5b67b387244c2c909da779a1478 \
		-s none -f -o test.esl.sha256.addition.unsorted.esl.result

test.esl.sha256.addition.unsorted: test.esl.sha256.addition.unsorted.esl.result.txt
test.esl.sha256.addition.unsorted: test.esl.sha256.addition.unsorted.esl.goal.txt
	$(quiet)echo testing adding a sha256 sum to an existing ESL '(unsorted)'
	$(quiet)if ! cmp $@.esl.goal $@.esl.result ; then \
		diff -U 200 $@.esl.goal.txt $@.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)echo passed

test.esl.cert.addition.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 \
		-i test.esl.sha256.unsorted.esl.goal -a -c test.esl.cert.addition.cert.cer \
		-f -o test.esl.cert.addition.esl.result

test.esl.cert.addition:
	$(quiet)echo testing ESL entry addition with x509 cert
	$(quiet)$(MAKE) test.esl.cert.addition.esl.result.txt test.esl.cert.addition.esl.goal.txt
	$(quiet)if ! cmp test.esl.cert.addition.esl.goal test.esl.cert.addition.esl.result ; then \
		diff -U 200 test.esl.cert.addition.esl.goal.txt test.esl.cert.addition.esl.result.txt ; \
		exit 1 ; \
	fi
	$(quiet)rm -f test.esl.cert.addition.esl.result test.esl.cert.addition.*.esl.txt
	$(quiet)echo passed

test.esl.cert.removal.esl.goal.txt : test.esl.cert.removal.esl.goal

test.esl.cert.removal.esl.result:
	$(quiet)LD_LIBRARY_PATH=$(TOPDIR)/src $(EFISECDB) -g {redhat} -t sha256 \
		-i test.esl.cert.addition.cert.esl.goal -r -c test.esl.cert.addition.cert.cer \
		-f -o test.esl.cert.removal.esl.result

test.esl.cert.removal:
	$(quiet)echo testing ESL entry removal with x509 cert

=== debian/changelog ===
efivar (38-3.1deepin1) unstable; urgency=medium

  * Revert t64 and build=any.

 -- xiangzelong <xiangzelong@deepin.org>  Fri, 10 Jan 2025 14:33:41 +0800

efivar (38-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062526

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 02:57:40 +0000

efivar (38-3) unstable; urgency=medium

  [ Mate Kukri ]
  * d/p/0001-linux-handle-non-ACPI-systems-in-device_get.patch:
    Rebase on current upstream version and include in series

 -- Steve McIntyre <93sam@debian.org>  Wed, 29 Nov 2023 14:30:24 +0000

efivar (38-2) unstable; urgency=medium

  * Don't compile with -march=native. Closes: #1055123

 -- Steve McIntyre <93sam@debian.org>  Wed, 01 Nov 2023 00:39:42 +0000

efivar (38-1) unstable; urgency=medium

  [ Mario Limonciello ]
  * New upstream version (38)
  * Drop all patches, upstream
  * debian/*:
    - Create new binary packages for new library libefisec1
    - Add efisecdb to efivar binary package
  * debian/control:
    - Add mandoc to build depends
    - add grub-common to build depends for unit tests
  * debian/rules:
    - disable link time optimization to fix FTBFS
    - turn off verbose builds by default
    - set prefix for *-editenv command for unit tests

  [ Steve McIntyre ]
  * Add loong64 to arch lists for packages. Closes: #1055083

 -- Steve McIntyre <93sam@debian.org>  Tue, 31 Oct 2023 11:40:31 +0000

=== debian/control ===
Source: efivar
Priority: optional
Maintainer: Debian UEFI Maintainers <debian-efi@lists.debian.org>
Uploaders: Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libpopt-dev, pkg-config, mandoc, grub-common
Standards-Version: 4.1.1
Section: libs
Homepage: https://github.com/rhinstaller/efivar
Vcs-Git: https://salsa.debian.org/efi-team/efivar.git
Vcs-Browser: https://salsa.debian.org/efi-team/efivar

Package: libefivar-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefivar1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefivar
 development headers required to use libefivar

Package: libefiboot-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefiboot1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefiboot
 development headers required to use libefiboot

Package: libefisec-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefisec1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefisec
 development headers required to use libefisec

Package: efivar
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libefivar1 (= ${binary:Version}), libefiboot1 (= ${binary:Version})
Description: Tools to manage UEFI variables
 efivar provides a simple command line interface to the UEFI variable facility.

Package: libefiboot1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the manipulation of UEFI variables related to booting.

Package: libefivar1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables.

Package: libefisec1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: efibootmgr (<< 0.12-2)
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables related to
 security.

## efivar 39

=== Makefile ===
export TOPDIR = $(realpath $(dir $(firstword $(MAKEFILE_LIST))))

include $(TOPDIR)/src/include/deprecated.mk
include $(TOPDIR)/src/include/version.mk
include $(TOPDIR)/src/include/rules.mk
include $(TOPDIR)/src/include/defaults.mk
include $(TOPDIR)/src/include/coverity.mk
include $(TOPDIR)/src/include/scan-build.mk

SUBDIRS := src
ifeq ($(ENABLE_DOCS), 1)
SUBDIRS += docs
endif

all : | efivar.spec src/include/version.mk prep
all clean install prep :
	@set -e ; for x in $(SUBDIRS) ; do \
		$(MAKE) -C $$x $@ ; \
	done

abicheck abidw efisecdb efisecdb-static efivar efivar-static static : | all
	$(MAKE) -C src $@

abiupdate :
	$(MAKE) clean all
	$(MAKE) -C src abiclean abixml

$(SUBDIRS) :
	$(MAKE) -C $@ all

brick : all
	@echo -n $(info this is the rule for brick PWD:$(PWD) MAKECMDGOALS:$(MAKECMDGOALS))
	@set -e ; for x in $(SUBDIRS) ; do \
		$(MAKE) -C $${x} test ; \
	done

a :
	@if [ $${EUID} != 0 ]; then \
		echo no 1>&2 ; \
		exit 1 ; \
	fi

GITTAG = $(shell bash -c "echo $$(($(VERSION) + 1))")

efivar.spec : | Makefile src/include/version.mk

clean : clean-toplevel
clean-toplevel:
	@rm -vf efivar.spec vgcore.* core.*
	@$(MAKE) -C tests clean

test : all
	@$(MAKE) -C tests

test-archive: abicheck efivar.spec
	@rm -rf /tmp/efivar-$(GITTAG) /tmp/efivar-$(GITTAG)-tmp
	@mkdir -p /tmp/efivar-$(GITTAG)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/efivar-$(GITTAG)-tmp/ ; tar x )
	@git diff | ( cd /tmp/efivar-$(GITTAG)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/efivar-$(GITTAG)-tmp/ /tmp/efivar-$(GITTAG)/
	@cp efivar.spec /tmp/efivar-$(GITTAG)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/efivar-$(GITTAG).tar.bz2 efivar-$(GITTAG)
	@rm -rf /tmp/efivar-$(GITTAG)
	@echo "The archive is in efivar-$(GITTAG).tar.bz2"

bumpver :
	@echo VERSION=$(GITTAG) > src/include/version.mk
	@git add src/include/version.mk
	git commit -m "Bump version to $(GITTAG)" -s

tag:
	git tag -s $(GITTAG) refs/heads/master

archive: abicheck bumpver abidw tag efivar.spec
	@rm -rf /tmp/efivar-$(GITTAG) /tmp/efivar-$(GITTAG)-tmp
	@mkdir -p /tmp/efivar-$(GITTAG)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/efivar-$(GITTAG)-tmp/ ; tar x )
	@mv /tmp/efivar-$(GITTAG)-tmp/ /tmp/efivar-$(GITTAG)/
	@cp efivar.spec /tmp/efivar-$(GITTAG)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/efivar-$(GITTAG).tar.bz2 efivar-$(GITTAG)
	@rm -rf /tmp/efivar-$(GITTAG)
	@echo "The archive is in efivar-$(GITTAG).tar.bz2"

.PHONY: $(SUBDIRS)
.PHONY: a abiclean abicheck abidw abiupdate all archive
.PHONY: brick bumpver clean clean-toplevel
.PHONY: efivar efivar-static
.PHONY: install prep tag test test-archive
.NOTPARALLEL:

=== src/Makefile ===
--- 
+++ 
@@ -4,7 +4,6 @@
 include $(TOPDIR)/src/include/version.mk
 include $(TOPDIR)/src/include/rules.mk
 include $(TOPDIR)/src/include/defaults.mk
-include $(TOPDIR)/src/include/workarounds.mk
 
 LIBTARGETS=libefivar.so libefiboot.so libefisec.so
 STATICLIBTARGETS=libefivar.a libefiboot.a libefisec.a
@@ -28,9 +27,12 @@
 EFISECDB_SOURCES = efisecdb.c guid-symbols.c secdb-dump.c util.c
 EFISECDB_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(EFISECDB_SOURCES)))
 GENERATED_SOURCES = include/efivar/efivar-guids.h guid-symbols.c
-MAKEGUIDS_SOURCES = makeguids.c util.c
+MAKEGUIDS_SOURCES = makeguids.c util-makeguids.c
 MAKEGUIDS_OBJECTS = $(patsubst %.S,%.o,$(patsubst %.c,%.o,$(MAKEGUIDS_SOURCES)))
-MAKEGUIDS_OUTPUT = $(GENERATED_SOURCES) guids.lds
+MAKEGUIDS_OUTPUT = $(GENERATED_SOURCES)
+
+util-makeguids.c : util.c
+	cp util.c util-makeguids.c
 
 ALL_SOURCES=$(LIBEFISEC_SOURCES) $(LIBEFIBOOT_SOURCES) $(LIBEFIVAR_SOURCES) \
 	    $(MAKEGUIDS_SOURCES) $(GENERATED_SOURCES) $(EFIVAR_SOURCES) \
@@ -81,61 +83,61 @@
 	if [ "$${missing}" != "no" ]; then \
 		exit 1 ; \
 	fi
-	./makeguids $(LD_DASH_T) guids.txt guid-symbols.c include/efivar/efivar-guids.h guids.lds
+	./makeguids guids.txt guid-symbols.c include/efivar/efivar-guids.h
 
 prep : makeguids $(GENERATED_SOURCES)
 
-$(LIBEFIVAR_OBJECTS) $(LIBEFIBOOT_OBJECTS) : prep
+$(LIBEFIVAR_OBJECTS) $(LIBEFIBOOT_OBJECTS) : include/efivar/efivar-guids.h
 
 libefivar.a : | $(GENERATED_SOURCES)
 libefivar.a : $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))
 
 libefivar.so : $(LIBEFIVAR_OBJECTS)
 libefivar.so : | $(GENERATED_SOURCES) libefivar.map
-libefivar.so : LIBS=dl
-libefivar.so : LDSCRIPTS=guids.lds
-libefivar.so : MAP=libefivar.map
+libefivar.so : private LIBS=dl
+libefivar.so : private MAP=libefivar.map
 
 efivar : $(EFIVAR_OBJECTS) | libefivar.so
-efivar : LIBS=efivar dl
+efivar : private LIBS=efivar dl
 
 efivar-static : $(EFIVAR_OBJECTS) $(patsubst %.o,%.static.o,$(LIBEFIVAR_OBJECTS))
 efivar-static : | $(GENERATED_SOURCES)
-efivar-static : LIBS=dl
+efivar-static : private LIBS=dl
 
 libefiboot.a : $(patsubst %.o,%.static.o,$(LIBEFIBOOT_OBJECTS))
 
 libefiboot.so : $(LIBEFIBOOT_OBJECTS)
 libefiboot.so : | libefiboot.map libefivar.so
-libefiboot.so : LIBS=efivar
-libefiboot.so : MAP=libefiboot.map
+libefiboot.so : private LIBS=efivar
+libefiboot.so : private MAP=libefiboot.map
 
 libefisec.a : $(patsubst %.o,%.static.o,$(LIBEFISEC_OBJECTS))
 
 libefisec.so : $(LIBEFISEC_OBJECTS)
 libefisec.so : | libefisec.map
-libefisec.so : MAP=libefisec.map
+libefisec.so : private MAP=libefisec.map
 
 efisecdb : $(EFISECDB_OBJECTS) | libefisec.so
-efisecdb : LIBS=efivar efisec dl
+efisecdb : private LIBS=efivar efisec dl
 
 efisecdb-static : $(EFISECDB_OBJECTS)
 efisecdb-static : $(patsubst %.o,%.static.o,$(LIBEFISEC_OBJECTS) $(LIBEFIVAR_OBJECTS))
 efisecdb-static : | $(GENERATED_SOURCES)
-efisecdb-static : LIBS=dl
+efisecdb-static : private LIBS=dl
 
 thread-test : libefivar.so
-thread-test : CFLAGS=$(HOST_CFLAGS) -I$(TOPDIR)/src/include/efivar
-thread-test : LIBS=pthread efivar
+# make sure we don't propagate CFLAGS to object files used by 'libefivar.so'
+thread-test.o : private CFLAGS=$(HOST_CFLAGS) -I$(TOPDIR)/src/include/efivar
+thread-test : private LIBS=pthread efivar
 
 deps : $(ALL_SOURCES)
 	@$(MAKE) -f $(SRCDIR)/include/deps.mk deps SOURCES="$(ALL_SOURCES)"
 
 clean : 
 	@rm -rfv *~ *.o *.a *.E *.so *.so.* *.pc *.bin .*.d *.map \
-		makeguids guid-symbols.c include/efivar/efivar-guids.h \
-		guids.lds \
-		$(TARGETS) $(STATICTARGETS)
+		makeguids guid-symbols.c util-makeguids.c	\
+		include/efivar/efivar-guids.h $(TARGETS)	\
+		$(STATICTARGETS)
 	@# remove the deps files we used to create, as well.
 	@rm -rfv .*.P .*.h.P *.S.P include/efivar/.*.h.P

=== debian/changelog ===
efivar (39-2) unstable; urgency=medium

  * Add s390x and ppc64el to architectures
  * Backport a patch from upstream to enable storing variables on ESP.
    (Closes: #1102494)

 -- Mario Limonciello <superm1@debian.org>  Tue, 19 Aug 2025 22:54:25 -0500

efivar (39-1) unstable; urgency=medium

  * d/watch: update
  * Drop upstream patch
  * Refresh no_host_march patch
  * d/control: Update standards version
  * d/control: update my email
  * d/control: b-d on pkgconf instead of pkg-config
  * Add salsa-ci.yml
  * Correct upstream address information

 -- Mario Limonciello <superm1@debian.org>  Mon, 18 Aug 2025 14:49:44 -0500

=== debian/control ===
Source: efivar
Priority: optional
Maintainer: Debian UEFI Maintainers <debian-efi@lists.debian.org>
Uploaders: Steve McIntyre <93sam@debian.org>, Mario Limonciello <superm1@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libpopt-dev, pkgconf, mandoc, grub-common
Standards-Version: 4.7.2.0
Section: libs
Homepage: https://github.com/rhboot/efivar
Vcs-Git: https://salsa.debian.org/efi-team/efivar.git
Vcs-Browser: https://salsa.debian.org/efi-team/efivar

Package: libefivar-dev
Section: libdevel
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Depends: libefivar1t64 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefivar
 development headers required to use libefivar

Package: libefiboot-dev
Section: libdevel
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Depends: libefiboot1t64 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefiboot
 development headers required to use libefiboot

Package: libefisec-dev
Section: libdevel
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Depends: libefisec1t64 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefisec
 development headers required to use libefisec

Package: efivar
Section: admin
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libefivar1t64 (= ${binary:Version}), libefiboot1t64 (= ${binary:Version})
Description: Tools to manage UEFI variables
 efivar provides a simple command line interface to the UEFI variable facility.

Package: libefiboot1t64
Provides: ${t64:Provides}
Replaces: libefiboot1
Breaks: libefiboot1 (<< ${source:Version})
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the manipulation of UEFI variables related to booting.

Package: libefivar1t64
Provides: ${t64:Provides}
Replaces: libefivar1
Breaks: libefivar1 (<< ${source:Version})
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables.

Package: libefisec1t64
Provides: ${t64:Provides}
Replaces: libefisec1
Architecture: amd64 i386 ia64 armhf arm64 armel riscv64 x32 mips64el ppc64el loong64 s390x
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libefisec1 (<< ${source:Version}), efibootmgr (<< 0.12-2)
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables related to
 security.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
#export DH_OPTIONS=-V

include /usr/share/dpkg/default.mk

ifeq ($(DEB_HOST_ARCH),amd64)
export DEB_CFLAGS_MAINT_APPEND+= -fcf-protection
export DEB_LDFLAGS_MAINT_APPEND+= -fcf-protection
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- LIBDIR=\$${PREFIX}/lib/$(DEB_HOST_MULTIARCH) CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-

override_dh_auto_install:
	dh_auto_install -- LIBDIR=\$${PREFIX}/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	dh_auto_test -- GRUB_PREFIX=grub

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/rhboot/efivar/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
